/* OthelloHuman.java */

import java.awt.event.*;

/** Othello Player. */
public class OthelloHuman
	implements OthelloPlayer, MouseListener
{
	/** Player's color. */
	private int color;
	/** Gameboard. */
	private OthelloBoard board;
	/** Othello interface. */
	private Othello o;
	
	/** Creates a human player.
	    It needs to know its own color, and an Othello object. */
	public OthelloHuman(int color, Othello o)
	{
		this.color=color;
		this.o=o;
	}
	
	/** Returns the player's color. */
	public int getColor()
	{
		return color;
	}
	
	/** Starts the player's move.
	    This method will wait for any mouse action before actually doing anything. */
	public void startMove(OthelloBoard ob)
	{
		board=ob;
		o.addMouseListener(this);
	}
	
	/** Cancels player's move. */
	public void stopMove()
	{
		o.removeMouseListener(this);
	}
	
	/** Derived from MouseListener. */
	public void mouseClicked(MouseEvent e) {}
	
	/** Derived from MouseListener. */
	public void mouseEntered(MouseEvent e) {}
	
	/** Derived from MouseListener. */
	public void mouseExited(MouseEvent e) {}
	
	/** Derived from MouseListener.
	    Will try and place a chip under the mouse pointer. */
	public void mousePressed(MouseEvent e)
	{
		// If game is running and it's player's turn...
		int x=e.getX()-16;
		int y=e.getY()-16;
		if(x<0 || x>=40*board.getWidth() || y<0 || y>=40*board.getHeight())
			return;
		x/=40;
		y/=40;
		if(o.tryToSet(x, y))
		{
			o.removeMouseListener(this);
		}
	}
	
	/** Derived from MouseListener. */
	public void mouseReleased(MouseEvent e) {}
}
